<?php

namespace App\Http\Controllers\Catalogos;

use App\Models\Catalogos\Cliente; 
use App\Http\Controllers\Controller as Controller;
use Illuminate\Http\Request as Peticion;
use Firebase\JWT\JWT;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;

class ClienteController extends Controller
{
    private $respuesta;
    public function __construct()
    {
        //
        $this->respuesta = new \stdclass();
        $this->respuesta->notificacion = new \stdclass();
        $this->respuesta->notificacion->mensaje = '';
        $this->respuesta->data = new \stdclass();
    }

    public function show(Peticion $request)
    {
        $per_page = 10;
        $params = [];
        $sorting = 'nombre';
        $order = 'desc';
        if ($request->has('per_page')) {
            $per_page = $request->per_page;
        }
        if ($request->has('order')) {
            $order = $request->order;
        }
        if ($request->has('sorting')) {
            $sorting = $request->sorting;
        }

        if (!is_null($request->getQueryString())) {
            $params = [];
            if ($request->has('id')) {
                $params[] = ['id', '=', $request->id];
                $data =  Cliente::where($params)
                ->first();
                $this->respuesta->data = $data;
                
            }else{
                if ($request->has('nombre')) {
                    $params[] = ['nombre', 'ilike', "%".$request->nombre."%"];
                }
                $data = Cliente::where($params)
                ->orderBy($sorting, $order)
                ->paginate($per_page);
                $this->respuesta->data = $data;
            }

        }else{
            $data = Cliente::
            orderBy($sorting, $order)
            ->paginate($per_page);
            $this->respuesta->data = $data;
        }

        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        return response()->json($this->respuesta,
            200
        );

    }

    public function find($id)
    {
        $data = Cliente::find($id);
        if(!$data){
            $this->respuesta->notificacion->mensaje = 'No se encontro informacion';
            $this->respuesta->notificacion->tipo = 'warning';
            $this->respuesta->data = $data;
            return response()->json($this->respuesta,
                404
            );
        }
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );
    }

    public function store(Peticion $request)
    {
        $token = $request->header('Authorization');
        $usuarioSistema = JWT::decode($token, getenv('APP_KEY'), ['HS256']);

        //guardamose l articulo
        $row = new Cliente;
        $this->recuperarDatos($request, $row);
        $row->save();
        
        //formamos la respuesta para respuesta
        $data = new \stdClass;
        $data->id = $row->id;
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );
    }

    public function update($id, Peticion $request)
    {

        //verificar si ya existe el registro
        $row = Cliente::find($id);

        $this->recuperarDatos($request, $row);

        //verificar si cambio la etapa
        $row->save();


        //formamos la respuesta para respuesta
        $data = new \stdClass;
        $data->id = $newRow->id;
        $this->respuesta->notificacion->mensaje = 'Registro guardado correctamente';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );


    }

    public function delete($id)
    {
        $row = Cliente::find($id);
        $result = $row->delete();

        $data = new \stdClass;
        $data->id = $newRow->id;
        $this->respuesta->notificacion->mensaje = 'Registro eliminado correctamente';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $result;
        return response()->json($this->respuesta,
            200
        );
    }

    private function recuperarDatos(Peticion $request, &$registroGuardar){

        $token = $request->header('Authorization');
        $usuarioSistema = JWT::decode($token, getenv('APP_KEY'), ['HS256']);
        //usuario que captura el registro
        $registroGuardar->usuario_id = $usuarioSistema->data->id;
        if ($request->has('nombre')) {
            $registroGuardar->nombre = $request->nombre;
        }
        if ($request->has('apellidopaterno')) {
            $registroGuardar->apellidopaterno = $request->apellidopaterno;
        }
        if ($request->has('apellidomaterno')) {
            $registroGuardar->apellidomaterno = $request->apellidomaterno;
        }
        if ($request->has('telefono')) {
            $registroGuardar->telefono = $request->telefono;
        }
        if ($request->has('email')) {
            $registroGuardar->email = $request->email;
        }
        if ($request->has('lineacredito')) {
            $registroGuardar->lineacredito = $request->lineacredito;
        }
        if ($request->has('fechanacimiento')) {
            $registroGuardar->fechanacimiento = $request->fechanacimiento;
        }
        if ($request->has('domicilio')) {
            $registroGuardar->domicilio = $request->domicilio;
        }
    }

    public function listaKeyValue(Peticion $request)
    {
        $sorting = 'nombre';
        $order = 'asc';
        $params = [];
        $resultSet = Cliente::
                select('id', 'nombre' )
                ->orderBy($sorting, $order)
                ->get();
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $resultSet;
        return response()->json($this->respuesta,
            200
        );

    }

}
