<?php

namespace App\Http\Controllers\Catalogos;

use App\Models\Catalogos\FormaPago; 
use App\Http\Controllers\Controller as Controller;
use Illuminate\Http\Request as Peticion;
use Firebase\JWT\JWT;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;

class FormaPagoController extends Controller
{
    private $respuesta;
    public function __construct()
    {
        //
        $this->respuesta = new \stdclass();
        $this->respuesta->notificacion = new \stdclass();
        $this->respuesta->notificacion->mensaje = '';
        $this->respuesta->data = new \stdclass();
    }

    public function show(Peticion $request)
    {
        $per_page = 10;
        $params = [];
        $sorting = 'descripcion';
        $order = 'desc';
        if ($request->has('per_page')) {
            $per_page = $request->per_page;
        }
        if ($request->has('order')) {
            $order = $request->order;
        }
        if ($request->has('sorting')) {
            $sorting = $request->sorting;
        }

        if (!is_null($request->getQueryString())) {
            $params = [];
            if ($request->has('id')) {
                $params[] = ['id', '=', $request->id];
                $data =  Categoria::where($params)
                ->first();
                $this->respuesta->data = $data;
                
            }else{
                if ($request->has('descripcion')) {
                    $params[] = ['descripcion', 'ilike', "%".$request->descripcion."%"];
                }
                $data = FormaPago::where($params)
                ->orderBy($sorting, $order)
                ->paginate($per_page);
                $this->respuesta->data = $data;
            }

        }else{
            $data = FormaPago::
            orderBy($sorting, $order)
            ->paginate($per_page);
            $this->respuesta->data = $data;
        }

        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        return response()->json($this->respuesta,
            200
        );

    }

    public function find($id)
    {
        $data = FormaPago::find($id);
        if(!$data){
            $this->respuesta->notificacion->mensaje = 'No se encontro informacion';
            $this->respuesta->notificacion->tipo = 'warning';
            $this->respuesta->data = $data;
            return response()->json($this->respuesta,
                404
            );
        }
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );
    }

    public function store(Peticion $request)
    {
        $token = $request->header('Authorization');
        $usuarioSistema = JWT::decode($token, getenv('APP_KEY'), ['HS256']);

        //guardamose l articulo
        $row = new FormaPago;
        $this->recuperarDatos($request, $row);
        $row->save();
        
        //formamos la respuesta para respuesta
        $data = new \stdClass;
        $data->id = $row->id;
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );
    }

    public function update($id, Peticion $request)
    {

        //verificar si ya existe el registro
        $row = FormaPago::find($id);

        $this->recuperarDatos($request, $row);

        //verificar si cambio la etapa
        $row->save();


        //formamos la respuesta para respuesta
        $data = new \stdClass;
        $data->id = $newRow->id;
        $this->respuesta->notificacion->mensaje = 'Registro guardado correctamente';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );


    }

    public function delete($id)
    {
        $row = FormaPago::find($id);
        $result = $row->delete();

        $data = new \stdClass;
        $data->id = $newRow->id;
        $this->respuesta->notificacion->mensaje = 'Registro eliminado correctamente';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $result;
        return response()->json($this->respuesta,
            200
        );
    }

    private function recuperarDatos(Peticion $request, &$registroGuardar){

        $token = $request->header('Authorization');
        $usuarioSistema = JWT::decode($token, getenv('APP_KEY'), ['HS256']);
        //usuario que captura el registro
        $registroGuardar->usuario_id = $usuarioSistema->data->id;
        if ($request->has('descripcion')) {
            $registroGuardar->descripcion = $request->descripcion;
        }
        if ($request->has('descripcion')) {
            $registroGuardar->descripcion = $request->descripcion;
        }
    }

    public function listaKeyValue(Peticion $request)
    {
        $sorting = 'descripcion';
        $order = 'asc';
        $params = [];
        $resultSet = FormaPago::
                select('id', 'descripcion' )
                ->orderBy($sorting, $order)
                ->get();
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $resultSet;
        return response()->json($this->respuesta,
            200
        );

    }
    public function getForOffLine(Peticion $request)
    {
        $per_page = 10;
        $params = [];
        $paramsInv = [];
        $sorting = 'cat_formaspago.id';
        $order = 'asc';
        if ($request->has('per_page')) {
            $per_page = $request->per_page;
        }
                
                    
            
            $data = DB::table('cat_articulos')
            ->where($params)
            ->select('cat_formaspago.*')
            ->orderBy($sorting, $order)
            ->paginate($per_page);
            $this->respuesta->notificacion->mensaje = 'Exito';
            $this->respuesta->notificacion->tipo = 'success';
            $this->respuesta->data = $data;
            return response()->json($this->respuesta,
                200
            );

    }

}
