<?php

namespace App\Http\Controllers\Configuracion;

use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Http\Request as Peticion;
use App\Http\Controllers\Controller as Controller;
use Illuminate\Support\Facades\DB;
use App\Models\Configuracion\Configuracion;

class ConfiguracionController extends Controller
{
    private $respuesta;
    public function __construct()
    {
        $this->respuesta = new \stdclass();
        $this->respuesta->notificacion = new \stdclass();
        $this->respuesta->notificacion->estado = 0;
        $this->respuesta->notificacion->mensaje = '';
        $this->respuesta->data = new \stdclass();
    }

    public function show(Peticion $request)
    {  
        $per_page = 20;
        $params = [];
        $sorting = 'tipoconfiguracion_id';
        $order = 'asc'; // desc
        if($request->has('sucursal_id')){
            $params[] = ['sucursal_id', '=', $request->sucursal_id];
        }
        if($request->has('tipoconfiguracion_id')){
            $params[] = ['tipoconfiguracion_id', '=', $request->tipoconfiguracion_id];
        }
        if($request->has('contexto')){
            $params[] = ['contexto', '=', $request->contexto];
        }
        $data = Configuracion::where($params)->orderBy($sorting, $order)
                ->paginate($per_page);

        $this->respuesta->notificacion->estado = 0;
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );
    }

    public function find($id)
    {
        $data = Configuracion::find($id);
        if(!$data){
            $this->respuesta->notificacion->estado = 1;
            $this->respuesta->notificacion->mensaje = 'Registro no encontrado';
            $this->respuesta->notificacion->tipo = 'warning';
            $this->respuesta->data = $data;
            return response()->json($this->respuesta,
                404
            );
        }

        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );

    }

    public function store(Peticion $request)
    {
        $row = new Configuracion;
        $token = $request->header('Authorization');
        $usuarioSistema = JWT::decode($token, getenv('APP_KEY'), ['HS256']);

        $row->usuario_id = $usuarioSistema->data->id;
        if ($request->has('tipoconfiguracion_id')) {
            $row->tipoconfiguracion_id = $request->tipoconfiguracion_id;
        }
        if ($request->has('sucursal_id')) {
            $row->sucursal_id = $request->sucursal_id;
        }
        if ($request->has('configuracion')) {
            $row->configuracion = $request->configuracion;
        }

        $row->save();

        $this->respuesta->data = ["id"=>$row->id];
        $this->respuesta->notificacion->mensaje = 'Registro almacenado con exito';
        $this->respuesta->notificacion->tipo = 'success';
        return response()->json($this->respuesta,
            200
        );
    }

    public function update($id, Peticion $request)
    {
        
        
            $row = Configuracion::find($id);

            $token = $request->header('Authorization');
            $usuarioSistema = JWT::decode($token, getenv('APP_KEY'), ['HS256']);

            $row->usuario_id = $usuarioSistema->data->id;
            if ($request->has('tipoconfiguracion_id')) {
                $row->tipoconfiguracion_id = $request->tipoconfiguracion_id;
            }
            if ($request->has('sucursal_id')) {
                $row->sucursal_id = $request->sucursal_id;
            }
            if ($request->has('configuracion')) {
                $row->configuracion = $request->configuracion;
            }
            if ($request->has('configuracion')) {
                $row->configuracion = $request->configuracion;
            }
    
            $row->save();


        $this->respuesta->data = ["id"=>$row->id];
        $this->respuesta->notificacion->mensaje = 'Registro actualizado con exito';
        $this->respuesta->notificacion->tipo = 'success';
        return response()->json($this->respuesta,
            200
        );

    }

    public function delete($id)
    {
        $row = Configuracion::find($id);
        if(!$row){
            $data = new \stdClass;
            $this->respuesta->notificacion->estado = 1;
            $this->respuesta->notificacion->mensaje = 'Registro no encontrado';
            $this->respuesta->notificacion->tipo = 'warning';
            $this->respuesta->data = $data;
            return response()->json($this->respuesta,
                404
            );
        }
        $data = [
            "result" => $row->delete(),
        ];
        $this->respuesta->notificacion->mensaje= 'Registro eliminado correctamente';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );
    }


}
