<?php

namespace App\Http\Controllers\Seguridad;

use App\Models\Seguridad\OpcionSistema;
use App\Http\Controllers\Controller as Controller;
use Illuminate\Http\Request as Peticion;
use Illuminate\Support\Facades\DB;

class OpcionSistemaController extends Controller
{
    
    public function __construct()
    {
        //
    }

    public function show(Peticion $request)
    {
        $per_page = 15;
        $params = [];
        $sorting = 'nombreopcion';
        $order = 'asc';

        if ($request->has('per_page')) {
            $per_page = $request->per_page;
        }

        if (!is_null($request->getQueryString())) {
            $params = [];
            if ($request->has('id')) {
                $params[] = ['id', '=', $request->input('id')];
            }
            if ($request->has('nombreopcion')) {
                $params[] = ['nombreopcion', 'ilike', "%".$request->input('nombreopcion')."%"];
            }
            $registroEncontrado = OpcionSistema::
                where($params)
                ->with('secciones')
                ->orderBy($sorting, $order)
                ->paginate($per_page);
            
            if (isset($registroEncontrado)) {
                return $registroEncontrado;
            }
        }
        return OpcionSistema::with('secciones')
            ->orderBy($sorting, $order)
            ->paginate($per_page);
    }

    public function find($id)
    {
        return OpcionSistema::with('secciones')
        ->findOrFail($id);
        //return response()->json((OpcionSistema::findOrFail($id)));
    }

    public function menu()
    {
        $menu = array();
        $query = "SELECT id, idpadre, posicion, nombreopcion, state, 
                    nombreicono, created_at, updated_at, deleted_at
                    FROM public.cat_opcionessistema
                    ORDER BY idpadre,posicion;";
        $resultSet = DB::select($query);
        $menu = $this->generarMenu($resultSet, 0);
        return $menu;
    }

    private function generarMenu($array, $padreId = 0)
    {
        $menu = array();
        $arrayName = array();
        $arrayPadre = array();
        $contH = 0;
        $contPadre = 0;
        $secciones = array();
        $children = array();
      
        $array = json_decode(json_encode($array), true);
        foreach ($array as $elemento) {
            if ($elemento['idpadre']==$padreId) {
                $menu["url"] = $elemento['state'];
                $menu["name"]= $elemento['nombreopcion'];
                $menu["icon"]= $elemento['nombreicono'];
                $children = [];
                $children = $this->generarMenu($array, $elemento['id']);
                if(sizeof($children) > 0){
                    $menu["children"] =  $children;
                    
                }
                $menu['secciones'] = $this->secciones($elemento['id']);
                
                
                $arrayName[$contH] = $menu;
                $contH++;
            }
        }
        return $arrayName;
    }

    public function secciones($opcionsistema_id)
    {
        $secciones = array();
        $seccion = new  \stdclass();
        $query = "SELECT  nombreseccion
                    FROM public.cat_secciones
                    WHERE opcionsistema_id = ?;";
        $resultSet = DB::select($query, [$opcionsistema_id]);
        
        foreach ($resultSet as $row){
            $seccion = new  \stdclass();
            $seccion->nombreseccion = $row->nombreseccion;
            $seccion->permisos = array(false, false, false, false);
            
            array_push($secciones, $seccion);
        }
        return $secciones;
    }
}
