<?php

namespace App\Http\Controllers\Servicios;

use App\Models\Catalogos\Telefonica;
use App\Http\Controllers\Controller as Controller;
use Illuminate\Http\Request as Peticion;
use Firebase\JWT\JWT;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;

class TelefonicaController extends Controller
{
    private $respuesta;
    public function __construct()
    {
        //
        $this->respuesta = new \stdclass();
        $this->respuesta->notificacion = new \stdclass();
        $this->respuesta->notificacion->mensaje = '';
        $this->respuesta->data = new \stdclass();
    }

    public function show(Peticion $request)
    {
        $per_page = 10;
        $params = [];
        $sorting = 'nombre';
        $order = 'desc';
        if ($request->has('per_page')) {
            $per_page = $request->per_page;
        }
        if ($request->has('order')) {
            $order = $request->order;
        }
        if ($request->has('sorting')) {
            $sorting = $request->sorting;
        }

        if (!is_null($request->getQueryString())) {
            $params = [];
                if ($request->has('nombre')) {
                    $params[] = ['nombre', 'ilike', "%".$request->nombre."%"];
                }
                $data = Telefonica::where($params)
                ->orderBy($sorting, $order)
                ->paginate($per_page);
                $this->respuesta->notificacion->mensaje = 'Exito';
                $this->respuesta->notificacion->tipo = 'success';
                $this->respuesta->data = $data;
                return response()->json($this->respuesta,
                    200
                );
        }
        $data = Telefonica::orderBy($sorting, $order)
                ->paginate($per_page);
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );

        

    }

    public function find($id)
    {
        $data = Telefonica::find($id);
        if(!$data){
            $this->respuesta->notificacion->mensaje = 'No se encontro informacion';
            $this->respuesta->notificacion->tipo = 'warning';
            $this->respuesta->data = $data;
            return response()->json($this->respuesta,
                404
            );
        }
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );
    }

    public function store(Peticion $request)
    {
        $row = new Articulo;

        if ($request->has('id')) {
            $row->id = $request->id;
        }
        if ($request->has('nombre')) {
            $row->nombre = $request->nombre;
        }
        if ($request->has('status')) {
            $row->status = $request->status;
        }

        $data = $row->save();

        $this->respuesta->notificacion->mensaje = 'Registro guardado correctamente';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );
    }

    public function update($id, Peticion $request)
    {
        
        $row = Telefonica::find($id);

        if(!$row){
            $this->respuesta->notificacion->mensaje = 'Registro no encontrado';
            $this->respuesta->notificacion->tipo = 'success';
            $this->respuesta->data = $data;
            return response()->json($this->respuesta,
                404
            );
        }
        
        if ($request->has('id')) {
            $row->id = $request->id;
        }
        if ($request->has('nombre')) {
            $row->nombre = $request->nombre;
        }
        if ($request->has('status')) {
            $row->status = $request->status;
        }

        $data = $row->save();

        $this->respuesta->notificacion->mensaje = 'Registro guardado correctamente';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );


    }

    public function delete($id)
    {
        $row = Telefonica::find($id);
        if(!$row){
            $this->respuesta->notificacion->mensaje = 'Registro no encontrado';
            $this->respuesta->notificacion->tipo = 'success';
            $this->respuesta->data = $data;
            return response()->json($this->respuesta,
                404
            );
        }

        $result = $row->delete();

        $this->respuesta->notificacion->mensaje = 'Registro eliminado correctamente';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $result;
        return response()->json($this->respuesta,
            200
        );
    }
    public function listaKeyValue()
    {

        $data = Telefonica::where('status','=',1)
        ->select('id', 'nombre')
        ->orderBy('id', 'asc')
        ->get();

        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        $this->respuesta->data = $data;
        return response()->json($this->respuesta,
            200
        );

    }

}
