<?php

namespace App\Http\Controllers\Servicios;

use App\Models\Configuracion\Configuracion;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Http\Request as Peticion;
use App\Http\Controllers\Controller as Controller;
use Illuminate\Support\Facades\DB;
use GuzzleHttp\Client;
use Log;

class TiempoAireController extends Controller
{
    private $respuesta;
    private $servicio;
    public function __construct()
    {
        $this->servicio = getenv('API_TA_URL');
        $this->respuesta = new \stdclass();
        $this->respuesta->notificacion = new \stdclass();
        $this->respuesta->notificacion->estado = 0;
        $this->respuesta->notificacion->mensaje = '';
        $this->respuesta->data = new \stdclass();
    }

    public function show(Peticion $request)
    {  
        $this->respuesta->data = null;
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        return response()->json($this->respuesta,
            200
        );
    }

    public function find($id)
    {
        $this->respuesta->data = null;
        $this->respuesta->notificacion->mensaje = 'Exito';
        $this->respuesta->notificacion->tipo = 'success';
        return response()->json($this->respuesta,
            200
        );

    }

    public function store(Peticion $request)
    {
    
        $this->respuesta->data = null;
        $this->respuesta->notificacion->mensaje = 'Registro almacenado con exito';
        $this->respuesta->notificacion->tipo = 'success';
        return response()->json($this->respuesta,
            200
        );
    }

    public function update($id, Peticion $request)
    {
        
        $this->respuesta->data = ["id"=>$usuario->id];
        $this->respuesta->notificacion->mensaje = 'Registro actualizado con exito';
        $this->respuesta->notificacion->tipo = 'success';
        return response()->json($this->respuesta,
            200
        );

    }

    public function delete($id)
    {
            $data = new \stdClass;
            $this->respuesta->notificacion->estado = 0;
            $this->respuesta->notificacion->mensaje = 'Exito';
            $this->respuesta->notificacion->tipo = 'success';
            $this->respuesta->data = $data;
            return response()->json($this->respuesta,
                200
            );
    }

    public function getBalance(Peticion $request)
    {

        $userNameTA = '';
        $idclientepos = '';

        $configuracion = Configuracion::
                        where('sucursal_id','=',$request->sucursal_id)
                        ->where('tipoconfiguracion_id','=',2)
                        ->first();
        $dataConfig = json_decode( $configuracion->configuracion, true );
        $userNameTA = $dataConfig['usr'];
        $idclientepos = $dataConfig['idpos'];


        $url = $this->servicio . "/balance";
        $query = [
                'username'=>$userNameTA, 
                'idclientepos'=>$idclientepos,
            ];
            
        try{
            $client = new Client(['base_uri' => $url,]);
            $clientResponse = $client->request('GET', '', ['query' => $query]);
            $code = $clientResponse->getStatusCode();
            if($code == 200){
                $clientResponseData = $clientResponse->getBody();
                $remainingBytes = $clientResponseData->getContents();
                $resp = json_decode($remainingBytes);
                // return $resp->data;
                $this->respuesta->notificacion->mensaje = 'Exito';
                $this->respuesta->notificacion->tipo = 'success';
                $this->respuesta->data = $resp->data;
                return response()->json($this->respuesta,
                    200
                );

            }
            $this->respuesta->notificacion->mensaje = 'Exito';
            $this->respuesta->notificacion->tipo = 'success';
            $this->respuesta->data = '';
            return response()->json($this->respuesta,
                404
            );

        }catch(\Exception $e ){
            Log::info("Exception al consumir serviciospos " . $e);
            $this->respuesta->notificacion->mensaje = 'No es posible obtener el saldo de Tiempo Aire';
            $this->respuesta->notificacion->tipo = 'error';
            $this->respuesta->data = '';
            return response()->json($this->respuesta,
                500
            );
        }   
    }

}