<?php

namespace App\Models\Catalogos;

use Illuminate\Database\Eloquent\Model;

class Articulo extends Model
{
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'cat_articulos';

    protected $primaryKey = 'id';

    public $incrementing = true;

    public $timestamps = true;

    /**
     * Get the phone record associated with the user.
     */
    /**
     * Get the comments for the blog post.
     */
    public function departamento()
    {
        return $this->belongsTo('App\Models\Catalogos\Departamento');
    }
    public function categoria()
    {
        return $this->belongsTo('App\Models\Catalogos\Categoria');
    }

    public function inventarios()
    {
        return $this->hasMany('App\Models\Inventario\Inventario');
    }

    public function unidadmedida()
    {
        return $this->belongsTo('App\Models\Catalogos\UnidadMedida');
    }

    public function marca()
    {
        return $this->belongsTo('App\Models\Catalogos\Marca');
    }

    public function tipoetiqueta()
    {
        return $this->belongsTo('App\Models\Catalogos\TipoEtiqueta');
    }
    public function caracteristicas()
    {
        return $this->hasOne('App\Models\Catalogos\ArticuloCaracteristicas');
    }

    function articulospaquete(){
        return $this->hasMany('App\Models\Catalogos\Articulo');
    }
    /*
    function articulospaquete(){
        return $this->hasMany('App\Models\Catalogos\Articulo', 'espaquete');
    }
    public function parent()
    {
        return $this->belongsTo('App\Models\Catalogos\Articulo', 'espaquete');
    }
    */

}